/*
 * Blob.cpp
 *
 *  Created on: Oct 6, 2008
 *      Author: Santi
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif


#include "debug.h"

#include "Blob.h"
#include "KObjectCreator.h"

#include "Knightmare.h"

Blob::Blob(int x,int y,int sfx_volume,GLTManager *GLTM) : KEnemy(x,y,sfx_volume)
{
	int i;

	m_class = blob_symbol;

    m_n_states = 1;
    m_state_animations = new Animation *[1];

    for(i=0;i<1;i++) m_state_animations[i]=0;

    m_state = 0;

	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("blob_crawling_001"),8);
	a->addFrame(GLTM->get("blob_crawling_002"),8);
	a->addFrame(GLTM->get("blob_crawling_003"),8);
	a->addFrame(GLTM->get("blob_crawling_004"),8);
	a->addFrame(GLTM->get("blob_crawling_003"),8);
	a->addFrame(GLTM->get("blob_crawling_002"),8);
	m_state_animations[0]=a;

}


Blob::~Blob() {
}


bool Blob::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	if (!KEnemy::cycle(vcl,game,GLTM,SFXM)) return false;

	m_y+=0.25f;

	if (m_y>game->get_map_position()+500) return false;

	return true;
}


bool Blob::is_a(Symbol *c)
{
    if (c->cmp(blob_symbol))
        return true;

    return KEnemy::is_a(c);
} /* Blob::is_a */


bool Blob::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* Blob::is_a */
